unit Princ;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TF_Princ = class(TForm)
    Btn_Traitement: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Btn_Close: TButton;
    Btn_Traitement2: TButton;
    Rd_Jeu: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    Function Slope(i, n : integer) : Double ;
    Function Slope2(i, n : integer) : Double ;
    procedure Btn_TraitementClick(Sender: TObject);
    procedure Btn_CloseClick(Sender: TObject);
    procedure Btn_Traitement2Click(Sender: TObject);
    Function  Slope3(i, j : integer) : Double ;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  F_Princ: TF_Princ;
  NbPoints : Integer ;
  XPoint   : Array[1..30000] Of Double ;
  YPoint   : Array[1..30000] Of Double ;
  Precision : Double ;
  Xpt : Array[1..20000] of Double ;
  Ypt : Array[1..20000] of Double ;
  Npt : Integer ;
  
implementation

{$R *.dfm}

Uses Init, Init2, Math, Shellapi ;
{ ==================================================================== }
procedure TF_Princ.FormCreate(Sender: TObject);
Var
  i : Integer ;
begin
  Precision := 0.001 ;
end;
{ ==================================================================== }
Function TF_Princ.Slope(i, n : integer) : Double ;
// Calcul de la pente moyenne de n points  partir de i
Var
  j   : Integer ;
  Moy, X , Y  : Double ;
Begin
  Result := 0 ;
  If (i > NbPoints - n) Then Exit ;
  If (n < 2) Then Exit ;
  Moy := 0 ;
  For j := 1 To n - 1 Do
    Begin
      X := XPoint[i+j] - XPoint[i+j-1] ;
      Y := YPoint[i+j] - YPoint[i+j-1] ;
      If (X <> 0) Then  Moy := Moy + Y / X
                  Else  Moy := Infinity ;
    End ;
  Result := Moy / (n - 1) ;
End ;
{ ==================================================================== }
procedure TF_Princ.Btn_TraitementClick(Sender: TObject);
var
  F  : TextFile ;
  i  : Integer  ;
  j  : Integer  ;
  j1 : Integer ;
  OldSlope   : Double ;
  OldSlope2  : Double ;
  NewSlope   : Double ;
  n          : Integer ;
  JDeb, JFin : Integer ;
  Som3 : Double ;        // Somme des 3 dernires pentes calcules
  Som2 : Double ;        // Somme des avant 3 dernires pentes calcules
begin
  If (Rd_Jeu.ItemIndex = 0) Then
    Begin
      InitPoints(NbPoints, XPoint) ;
      For i := 1 To NbPoints Do YPoint[i] := i - 1 ;
    End
  Else
    Begin
      InitPoints2(NbPoints, XPoint) ;
      For i := 1 To NbPoints Do YPoint[i] := i - 1 ;
    End ;
  n := 2 ;
  AssignFile(F, 'Resultats.txt') ;
  Rewrite(F) ;
  OldSlope  := 0 ;
  OldSlope2 := 0 ;
  JDeb := 1 ;
  JFin := NbPoints -3 ;
  Som2 := 0 ;
  Som3 := 0 ;
  j1   := 0 ;
  Memo1.Clear ;
  Memo1.Lines.Add('Point' + Chr(9) + 'X') ;
  Writeln(F,'Point' + Chr(9) + 'X') ;
  Memo1.Lines.Add(' 1' + Chr(9) + FloatToStr(XPoint[1])) ;
  Writeln(F,' 1' + Chr(9) + FloatToStr(XPoint[1])) ;
  For j := JDeb to JFin Do
    Begin
      NewSlope := Slope(j, n) ;
      If (J > JDeb + 2) Then
        Begin
          Som3 := OldSlope2 + Oldslope + NewSlope ;
          Som3 := RoundTo(Som3,-2) ;
          If ((Abs(Som3 - Som2) > 0.01) And (j > j1+5)) Then
            Begin
              Memo1.Lines.Add(' ' + IntToStr(j-2) + Chr(9) + FloatToStr(XPoint[j-2])) ;
              Writeln(F,' ' + IntToStr(j-2) + Chr(9) + FloatToStr(XPoint[j-2]) ) ;
              J1 := j ;
            End ;
        End ;
      OldSlope2 := Oldslope ;
      OldSlope := NewSlope ;
      Som2 := Som3 ;
    End ;
  Memo1.Lines.Add(' ' + IntToStr(NbPoints)+ Chr(9) + FloatToStr(XPoint[NbPoints])) ;
  Writeln(F,' ' + IntToStr(NbPoints) + Chr(9) + FloatToStr(XPoint[NbPoints]) ) ;
  CloseFile(F);
//  ShellExecute(Handle,'open',PChar('NotePad'),PChar('Resultats.txt'),nil,SW_SHOW);
end;
{ ==================================================================== }
procedure TF_Princ.Btn_CloseClick(Sender: TObject);
begin
  Close ;
end;
{ ==================================================================== }
procedure TF_Princ.Btn_Traitement2Click(Sender: TObject);
Var
  i, j  : Integer ;
  j1 : Integer ;
  OldSlope   : Double ;
  NewSlope   : Double ;
  n          : Integer ;
  JDeb, JFin : Integer ;   // dbut et fin du jeu de points
  iMod       : Integer ;   // Nombre de points  "sauter" pour trouver un alignement
  Pente1, Pente2 : Double ;
begin
  // Initialisation du jeu de points
  If (Rd_Jeu.ItemIndex = 0) Then
    Begin
      InitPoints(NbPoints, XPoint) ;
      For i := 1 To NbPoints Do YPoint[i] := i - 1 ;
    End
  Else
    Begin
      InitPoints2(NbPoints, XPoint) ;
      For i := 1 To NbPoints Do YPoint[i] := i - 1 ;
    End ;
  IMod := 0 ;
  // Calcul de Imod pour connaitre l'alignement des points
  // On cherche sur les 10 premiers points
  i := 2 ;
  For j := i+1 To 10 Do
    Begin
      Pente1 := Slope3(i,j) ;
      Pente2 := Slope3(j, 2 * j - i) ;
{      ShowMessage('i : '+IntToStr(i)+'  -  j : '+IntToStr(j) +Chr(13)+
                  '  Pente '+IntToStr(i)+' '+IntToStr(j)+' j    : '+ FloatToStr(Pente1)+ Chr(13)+
                  '  Pente '+IntToStr(j)+' '+IntToStr(2*j-i)+' : '+ FloatToStr(Pente2)+ Chr(13)) ;    }
      If (Abs(Pente2 - Pente1) < 0.01) Then
        Begin
          Imod := j - i ;
          Break ;
        End ;
    End ;

  If (Imod = 0) Then
    Begin
      ShowMessage('Impossible de trouver des points aligns') ;
      Memo1.Lines.Add('Pas de segments ...') ;
      Exit ;
    End ;

  // On ne conserve qu'un point sur Imod (Points aligns)
  Memo1.Clear ;
  j := 0 ;
  For i := 1 To NbPoints Do
    Begin
      If ((i mod Imod)=1) Then
        Begin
          j := j + 1  ;
          Xpt[j] := XPoint[i] ;
          Ypt[j] := YPoint[i] ;
        End ;
    End ;
  Npt := j ;
  // Dbut de la recherche des extrmits des segments
  // On cherche quand la pente entre 2 points successifs varie
  n := 2 ;
  OldSlope  := 0 ;
  JDeb := 1 ;
  JFin := Npt -2 ;
  j1   := 0 ;
  Memo1.Clear ;
  Memo1.Lines.Add('Point' + Chr(9) + 'X') ;
  Memo1.Lines.Add(' ' + FloatToStr(YPoint[1]+1)+ Chr(9) + FloatToStr(XPoint[1])) ;
  For j := JDeb to JFin Do
    Begin
{      If (j < 10 ) Then
        Memo1.Lines.Add('j = '+IntToStr(j)+' - Xpt : '+FloatToStr(Xpt[j])+' - Ypt : '+ FloatToStr(Ypt[j])) ;  
}
      NewSlope := Slope2(j, n) ;
      If (J > JDeb + 1) Then
        Begin
          // si la pente varie et si le point est assez loign du prcdent on le garde
          // comme extrmit de segment 
          If ((Abs(NewSlope - OldSlope) > 0.1) And (j > j1+5)) Then
            Begin
              Memo1.Lines.Add(' ' +FloatToStr(YPt[j]+1) + Chr(9) + FloatToStr(XPt[j])) ;
              J1 := j ;
            End ;
        End ;
      OldSlope := NewSlope ;
    End ;
//  Memo1.Lines.Add(' ' + FloatToStr(YPt[Npt]+1)+ Chr(9) + FloatToStr(XPt[Npt])) ;
  Memo1.Lines.Add(' ' + FloatToStr(YPoint[NbPoints]+1)+ Chr(9) + FloatToStr(XPoint[NbPoints])) ;
  Memo1.Lines.Add(' Fin des segments  --------------- ' ) ;
end;
{ ==================================================================== }
Function TF_Princ.Slope2(i, n : integer) : Double ;
// Calcul de la pente moyenne de n points Xpt, Ypt  partir de i
Var
  j   : Integer ;
  Moy, X , Y  : Double ;
Begin
  Result := 0 ;
  If (i > Npt - n) Then Exit ;
  If (n < 2) Then Exit ;
  Moy := 0 ;
  For j := 1 To n - 1 Do
    Begin
      X := XPt[i+j] - XPt[i+j-1] ;
      Y := YPt[i+j] - YPt[i+j-1] ;
      If (X <> 0) Then  Moy := Moy + Y / X
                  Else  Moy := Infinity ;
    End ;
  Result := Moy / (n - 1) ;
End ;
{ ==================================================================== }
Function TF_Princ.Slope3(i, j : integer) : Double ;
// Calcul de la pente entre les points [Xpoint, YPoint]  n i et j
Var
  X , Y  : Double ;
Begin
  Result := 0 ;
  If (i >= NbPoints) Then Exit ;
  If (j > NbPoints) Then Exit ;
  If (i = j) Then Exit ;
  X := XPoint[j] - XPoint[i] ;
  Y := YPoint[j] - YPoint[i] ;
  If (X <> 0) Then  Result := Y / X
              Else  Result := 0 ;
End ;
{ ==================================================================== }

end.
